WhatsApp Template Management API

The Messages API now offers the WhatsApp Template Management API that allow you to manage templates for your WABAs and cut out the manual step of submitting and checking templates manually. You can manage your templates using the Template Management API, including adding new templates, retrieving their statuses, and deleting any that are already in use. Different sorts of media can be sent with each WhatsApp message template. You can manage your media files via the API and set up extra features to improve their functionality. See the Vonage Developer Portal for more information.

Download OpenAPI Specification

WhatsApp Template Management

Create and Manage WhatsApp Message Templates

List Templates

Get a list of templates,and their associated metadata, for the specified WABA ID. If multiple language variants exist for a template, each variant will be returned as a separate template object.

gethttps://api.nexmo.com/v2/whatsapp-manager/wabas/:id/templates

Authentication

KeyDescriptionWhereExample
Authorization

Your JSON web token.
Read more about JWTs

Headers

Bearer <JWT>

Path Parameters

id
string
Required
example345688589250625

The id of the WABA

Query Parameters

limit
number
Min1
Max500
Default25
example10

The number of templates to return in the list. Although the max size is 500, for large datasets it is recommended to use a lower limit and instead use pagination to avoid potential timeouts.

before
string
exampleMAZDZD

A cursor point used for a paginated request to indicate the template to paginate backwards from.

after
string
exampleMjQZD

A cursor point used for a paginated request to indicate the template to paginate forwards from.

category
string
exampleUTILITY

A filter for returning only templates matching a specific category.

Must be one of:UTILITYAUTHENTICATIONMARKETING
content
string
examplespecial offer

A search filter representing the content of a template. Only matching templates will be returned in the list.

language
string
exampleen

A filter for returning only templates matching a specific language code. A list of supported languages is available in the WhatsApp documentation

name
string
exampleMy Template

A search filter representing the name, either full or partial, of a template. Only matching templates will be returned in the list.

name_or_content
string
examplespecial offer

A search filter representing the name, either full or partial, or content of a template. Only matching templates will be returned in the list.

quality_score
string
exampleRED

A search filter representing the quality score of a template. Only matching templates will be returned in the list.

Must be one of:GREENYELLOWREDUNKNOWN
status
string
exampleAPPROVED

A filter for returning only templates matching a specific status.

Must be one of:APPROVEDIN_APPEALPENDINGREJECTEDDISABLEDPAUSEDLIMIT_EXCEEDED

Responses
Content Type
application/json

OK

Header Parameters
X-Request-Id
string(uuid)
examplef94b4e56-604e-07e5-e5ad-5a7228618f81
A unique identifier for the request, used for tracking and debugging
paging
object
cursors
object
before
string
exampleMAZDZD

The template before the first template in the current list

after
string
exampleMjQZD

The template after the last template in the current list

next
string(uri)
examplehttps://api.nexmo.com/v2/whatsapp-manager/wabas/106499765517625/templates?after=MwZDZD

A URI to ge the next paginated page.

previous
string(uri)
examplehttps://api.nexmo.com/v2/whatsapp-manager/wabas/106499765517625/templates?before=MgZDZD

A URI to ge the previous paginated page.

templates
array

An array of templates in the current list

id
string
example1045638762820500

The unique identifier for this template.

status
string
exampleAPPROVED

The status of the template. Templates with a status of APPROVED can be used in WhatsApp template messages.

Must be one of:APPROVEDREJECTEDIN_APPEALPENDINGPENDING_DELETIONDELETEDDISABLEDLOCKED
previous_category
string
exampleMARKETING

If the template has been updated to a different category, shows the previous category of the template.

name
string
Required
examplesample_issue_resolution

The name of the template

language
string
Required
exampleen

The language of the template. The same template name can be used for multiple language versions. A list of supported languages is available in the WhatsApp documentation. Note: Adding new languages on legacy template categories has been disabled by Meta, see the documentation for Language Variants and Categories

category
string
Required
exampleUTILITY

The required category of the template. The category determines what the template will be used for. Note: Adding new languages on legacy template categories has been disabled by Meta, see the documentation for Language Variants and Categories

Must be one of:UTILITYAUTHENTICATIONMARKETING
allow_category_change
boolean
exampletrue

This field is now deprecated. This functionality is now enabled by default by Meta and cannot be disabled. See the Meta documentation for more infomration.

An optional parameter which, when set to true, can avoid template rejection due to mis-categorization. Including this parameter, with a value of true, will allow Meta to re-assign the template to a different category as appropriate.

Must be one of:truefalse
components
array
Required

An array of objects representing the parts of the template itself. A template must have at least one component, and at least one component must be of type BODY. HEADER, FOOTER, and BUTTONS components are optional.

Any Of
One Of
One Of
type
string
exampleHEADER

The type of template component.

Must be one of:HEADER
format
string
exampleTEXT

The format of the template component. For a Text Header, format is always TEXT.

Must be one of:TEXT
text
string
Max60
exampleYour parcel is out for delivery.

The text to be displayed in this template component. Maximum 60 characters.

Example Response

{
   "paging": {
      "cursors": {
         "before": "MAZDZD",
         "after": "MjQZD"
      },
      "next": "https://api.nexmo.com/v2/whatsapp-manager/wabas/106499765517625/templates?after=MwZDZD",
      "previous": "https://api.nexmo.com/v2/whatsapp-manager/wabas/106499765517625/templates?before=MgZDZD"
   },
   "templates": [
      {
         "id": "1045638762820500",
         "status": "APPROVED",
         "previous_category": "MARKETING",
         "name": "sample_issue_resolution",
         "language": "en",
         "category": "UTILITY",
         "allow_category_change": true,
         "components": [
            {
               "type": "BODY",
               "text": "Your parcel will be delivered today"
            }
         ]
      }
   ]
}

Create Template

Submit a new template to be associated with this WABA

posthttps://api.nexmo.com/v2/whatsapp-manager/wabas/:id/templates

Authentication

KeyDescriptionWhereExample
Authorization

Your JSON web token.
Read more about JWTs

Headers

Bearer <JWT>

Path Parameters

id
string
Required
example345688589250625

The id of the WABA

Header Parameters

Content-Type
string

application/json

Request Body
Content Type
application/json

name
string
Required
examplesample_issue_resolution

The name of the template

language
string
Required
exampleen

The language of the template. The same template name can be used for multiple language versions. A list of supported languages is available in the WhatsApp documentation. Note: Adding new languages on legacy template categories has been disabled by Meta, see the documentation for Language Variants and Categories

category
string
Required
exampleUTILITY

The required category of the template. The category determines what the template will be used for. Note: Adding new languages on legacy template categories has been disabled by Meta, see the documentation for Language Variants and Categories

Must be one of:UTILITYAUTHENTICATIONMARKETING
allow_category_change
boolean
exampletrue

This field is now deprecated. This functionality is now enabled by default by Meta and cannot be disabled. See the Meta documentation for more infomration.

An optional parameter which, when set to true, can avoid template rejection due to mis-categorization. Including this parameter, with a value of true, will allow Meta to re-assign the template to a different category as appropriate.

Must be one of:truefalse
components
array
Required

An array of objects representing the parts of the template itself. A template must have at least one component, and at least one component must be of type BODY. HEADER, FOOTER, and BUTTONS components are optional.

Any Of
One Of
One Of
type
string
exampleHEADER

The type of template component.

Must be one of:HEADER
format
string
exampleTEXT

The format of the template component. For a Text Header, format is always TEXT.

Must be one of:TEXT
text
string
Max60
exampleYour parcel is out for delivery.

The text to be displayed in this template component. Maximum 60 characters.

Example Request

{
   "name": "sample_issue_resolution",
   "language": "en",
   "category": "UTILITY",
   "allow_category_change": true,
   "components": [
      {
         "type": "BODY",
         "text": "Your parcel will be delivered today"
      }
   ]
}

Responses
Content Type
application/json

OK

Header Parameters
X-Request-Id
string(uuid)
examplef94b4e56-604e-07e5-e5ad-5a7228618f81
A unique identifier for the request, used for tracking and debugging
id
string
Required
example408766354711449

The unique ID of the created template.

Example Response

{
   "id": "408766354711449"
}

Delete Template

Delete a template of the specified name associated with the WABA ID

deletehttps://api.nexmo.com/v2/whatsapp-manager/wabas/:id/templates

Authentication

KeyDescriptionWhereExample
Authorization

Your JSON web token.
Read more about JWTs

Headers

Bearer <JWT>

Path Parameters

id
string
Required
example345688589250625

The id of the WABA

Query Parameters

name
string

The name of the template to be deleted. The name is required, but if specified without hsm_id being specified then all templates matching that name will be deleted.

hsm_id
string

The ID of the specific template to be deleted. Only the template matching both the specified name and hsm_id will be deleted.

Responses

No Content - Resource successfully deleted

Header Parameters
X-Request-Id
string(uuid)
examplef94b4e56-604e-07e5-e5ad-5a7228618f81
A unique identifier for the request, used for tracking and debugging

Get Template

Get details of an existing template identified by the WABA and Template ID

gethttps://api.nexmo.com/v2/whatsapp-manager/wabas/:id/templates/:template_id

Authentication

KeyDescriptionWhereExample
Authorization

Your JSON web token.
Read more about JWTs

Headers

Bearer <JWT>

Path Parameters

id
string
Required
example345688589250625

The id of the WABA

template_id
string
Required
example1045638762820500

The id of the template

Responses
Content Type
application/json

OK

Header Parameters
X-Request-Id
string(uuid)
examplef94b4e56-604e-07e5-e5ad-5a7228618f81
A unique identifier for the request, used for tracking and debugging
id
string
example1045638762820500

The unique identifier for this template.

status
string
exampleAPPROVED

The status of the template. Templates with a status of APPROVED can be used in WhatsApp template messages.

Must be one of:APPROVEDREJECTEDIN_APPEALPENDINGPENDING_DELETIONDELETEDDISABLEDLOCKED
previous_category
string
exampleMARKETING

If the template has been updated to a different category, shows the previous category of the template.

name
string
Required
examplesample_issue_resolution

The name of the template

language
string
Required
exampleen

The language of the template. The same template name can be used for multiple language versions. A list of supported languages is available in the WhatsApp documentation. Note: Adding new languages on legacy template categories has been disabled by Meta, see the documentation for Language Variants and Categories

category
string
Required
exampleUTILITY

The required category of the template. The category determines what the template will be used for. Note: Adding new languages on legacy template categories has been disabled by Meta, see the documentation for Language Variants and Categories

Must be one of:UTILITYAUTHENTICATIONMARKETING
allow_category_change
boolean
exampletrue

This field is now deprecated. This functionality is now enabled by default by Meta and cannot be disabled. See the Meta documentation for more infomration.

An optional parameter which, when set to true, can avoid template rejection due to mis-categorization. Including this parameter, with a value of true, will allow Meta to re-assign the template to a different category as appropriate.

Must be one of:truefalse
components
array
Required

An array of objects representing the parts of the template itself. A template must have at least one component, and at least one component must be of type BODY. HEADER, FOOTER, and BUTTONS components are optional.

Any Of
One Of
One Of
type
string
exampleHEADER

The type of template component.

Must be one of:HEADER
format
string
exampleTEXT

The format of the template component. For a Text Header, format is always TEXT.

Must be one of:TEXT
text
string
Max60
exampleYour parcel is out for delivery.

The text to be displayed in this template component. Maximum 60 characters.

Example Response

{
   "id": "1045638762820500",
   "status": "APPROVED",
   "previous_category": "MARKETING",
   "name": "sample_issue_resolution",
   "language": "en",
   "category": "UTILITY",
   "allow_category_change": true,
   "components": [
      {
         "type": "BODY",
         "text": "Your parcel will be delivered today"
      }
   ]
}

Update Template

Update an existing template identified by the WABA and Template ID

puthttps://api.nexmo.com/v2/whatsapp-manager/wabas/:id/templates/:template_id

Authentication

KeyDescriptionWhereExample
Authorization

Your JSON web token.
Read more about JWTs

Headers

Bearer <JWT>

Path Parameters

id
string
Required
example345688589250625

The id of the WABA

template_id
string
Required
example1045638762820500

The id of the template

Header Parameters

Content-Type
string

application/json

Request Body
Content Type
application/json

name
string
Required
examplesample_issue_resolution

The name of the template

language
string
Required
exampleen

The language of the template. The same template name can be used for multiple language versions. A list of supported languages is available in the WhatsApp documentation. Note: Adding new languages on legacy template categories has been disabled by Meta, see the documentation for Language Variants and Categories

category
string
Required
exampleUTILITY

The required category of the template. The category determines what the template will be used for. Note: Adding new languages on legacy template categories has been disabled by Meta, see the documentation for Language Variants and Categories

Must be one of:UTILITYAUTHENTICATIONMARKETING
allow_category_change
boolean
exampletrue

This field is now deprecated. This functionality is now enabled by default by Meta and cannot be disabled. See the Meta documentation for more infomration.

An optional parameter which, when set to true, can avoid template rejection due to mis-categorization. Including this parameter, with a value of true, will allow Meta to re-assign the template to a different category as appropriate.

Must be one of:truefalse
components
array
Required

An array of objects representing the parts of the template itself. A template must have at least one component, and at least one component must be of type BODY. HEADER, FOOTER, and BUTTONS components are optional.

Any Of
One Of
One Of
type
string
exampleHEADER

The type of template component.

Must be one of:HEADER
format
string
exampleTEXT

The format of the template component. For a Text Header, format is always TEXT.

Must be one of:TEXT
text
string
Max60
exampleYour parcel is out for delivery.

The text to be displayed in this template component. Maximum 60 characters.

Example Request

{
   "name": "sample_issue_resolution",
   "language": "en",
   "category": "UTILITY",
   "allow_category_change": true,
   "components": [
      {
         "type": "BODY",
         "text": "Your parcel will be delivered today"
      }
   ]
}

Responses

No Content - Resource successfully deleted

Header Parameters
X-Request-Id
string(uuid)
examplef94b4e56-604e-07e5-e5ad-5a7228618f81
A unique identifier for the request, used for tracking and debugging

Media Upload

Upload media files to the WhatsApp platform. Once uploaded, you can use an uploaded file's handle to create a media template.

posthttps://api.nexmo.com/v2/whatsapp-manager/media/uploads

Authentication

KeyDescriptionWhereExample
Authorization

Your JSON web token.
Read more about JWTs

Headers

Bearer <JWT>

Query Parameters

file_type
string

The file's MIME type. Valid values are: image/jpeg, image/jpg, image/png, and video/mp4.

Header Parameters

Content-Type
string

multipart/form-data

Request Body
Content Type
multipart/form-data

mediafile
string(binary)
example--73dc24e0-b350-48f8-931e-eab338df00e1--

The file to be uploaded. See an example cURL request

Example Request

POST /v2/whatsapp-manager/media/uploads HTTP/1.1
Host: api.nexmo.com
Content-Type: application/x-www-form-urlencoded
Content-Length: 50

mediafile=--73dc24e0-b350-48f8-931e-eab338df00e1--

Responses
Content Type
application/json

OK

Header Parameters
X-Request-Id
string(uuid)
examplef94b4e56-604e-07e5-e5ad-5a7228618f81
A unique identifier for the request, used for tracking and debugging
h
string
example:c2FtcGxlLm1wNA==:image/jpeg:GKAj0gAUCZmJ1voFADip2iIAAAAAbugbAAAA:e:1472075513:ARZ_3ybzrQqEaluMUdI

The uploaded file's file handle. Media handles are valid for 30 days after the upload time, and can be used in template components for template creation.

Example Response

{
   "h": ":c2FtcGxlLm1wNA==:image/jpeg:GKAj0gAUCZmJ1voFADip2iIAAAAAbugbAAAA:e:1472075513:ARZ_3ybzrQqEaluMUdI"
}

Errors

The following is a non-exhaustive list of error codes that may occur while using this API.

These codes are in addition to any of our generic error codes.

CodeInformation
1000

Throttled - You have exceeded the submission capacity allowed on this account. Please wait and retry

1030

Internal error - There was an error processing your request in the Platform.